<template>
    <div>
        <div class="col-12 text-left">
            <h4>
                Avancement : {{progress}} %
            </h4>
        </div>
        <div class="clearfix"></div>
        <div v-if="tasks && tasks.length>0">
            <div class="row">
                <div class="col-2">
                    <h4>Nouvelle</h4>
                    <draggable v-model="newTasks" v-bind:options="{group:'tasks',sort: true}" v-on:change="update" class='draggble'>
                        <div v-for="element in newTasks" :key="element.title" class="element">
                            <div class="card">
                                <div class="card-block">
                                    <h4 class="card-title">{{element.title}}</h4>
                                    <p class="card-text">{{element.comment}}</p>
                                    <p class="card-text red">{{element.developer.firstname}} {{element.developer.lastname}}</p>
                                    <button class="btn btn-primary" v-on:click="edit(element)" v-if="canEdit">Modifier</button>
                                    <br>
                                </div>
                            </div>
                        </div>
                    </draggable>
                </div>
                <div class="col-2">
                    <h4>En Cours</h4>
                    <draggable v-model="DoingTasks" v-bind:options="{group:'tasks',sort: true}" v-on:change="update" class="draggble">
                        <div v-for="element in DoingTasks" :key="element.title" class="element">
                            <div class="card">
                                <div class="card-block">
                                    <h4 class="card-title">{{element.title}}</h4>
                                    <p class="card-text">{{element.comment}}</p>
                                    <p class="card-text red">{{element.developer.firstname}} {{element.developer.lastname}}</p>
                                    <button class="btn btn-primary" v-on:click="edit(element)" v-if="canEdit">Modifier</button>
                                    <br>
                                </div>
                            </div>
                        </div>
                    </draggable>
                </div>
                <div class="col-2">
                    <h4>Testée validée</h4>
                    <draggable v-model="ValidatedTasks" v-bind:options="{group:'tasks',sort: true}" v-on:change="update" class="draggble">
                        <div v-for="element in ValidatedTasks" :key="element.title" class="element">
                            <div class="card">
                                <div class="card-block">
                                    <h4 class="card-title">{{element.title}}</h4>
                                    <p class="card-text">{{element.comment}}</p>
                                    <p class="card-text red">{{element.developer.firstname}} {{element.developer.lastname}}</p>
                                    <button class="btn btn-primary" v-on:click="edit(element)" v-if="canEdit">Modifier</button>
                                    <br>
                                </div>
                            </div>
                        </div>
                    </draggable>
                </div>
                <div class="col-2">
                    <h4>Besoin information</h4>
                    <draggable v-model="InfoTasks" v-bind:options="{group:'tasks',sort: true}" v-on:change="update" class="draggble">
                        <div v-for="element in InfoTasks" :key="element.title" class="element">
                            <div class="card">
                                <div class="card-block">
                                    <h4 class="card-title">{{element.title}}</h4>
                                    <p class="card-text">{{element.comment}}</p>
                                    <p class="card-text red">{{element.developer.firstname}} {{element.developer.lastname}}</p>
                                    <button class="btn btn-primary" v-on:click="edit(element)" v-if="canEdit">Modifier</button>
                                    <br>
                                </div>
                            </div>
                        </div>
                    </draggable>
                </div>
                <div class="col-2">
                    <h4>Annulée</h4>
                    <draggable v-model="CancelledTasks" v-bind:options="{group:'tasks',sort: true}" v-on:change="update" class="draggble">
                        <div v-for="element in CancelledTasks" :key="element.title" class="element">
                            <div class="card">
                                <div class="card-block">
                                    <h4 class="card-title">{{element.title}}</h4>
                                    <p class="card-text">{{element.comment}}</p>
                                    <p class="card-text red">{{element.developer.firstname}} {{element.developer.lastname}}</p>
                                    <button class="btn btn-primary" v-on:click="edit(element)" v-if="canEdit">Modifier</button>
                                    <br>
                                </div>
                            </div>
                        </div>
                    </draggable>
                </div>
                <div class="col-2">
                    <h4>Testée non validée</h4>
                    <draggable v-model="NonValidatedTasks" v-bind:options="{group:'tasks',sort: true}" v-on:change="update" class="draggble">
                        <div v-for="element in NonValidatedTasks" :key="element.title" class="element">
                            <div class="card">
                                <div class="card-block">
                                    <h4 class="card-title">{{element.title}}</h4>
                                    <p class="card-text">{{element.comment}}</p>
                                    <p class="card-text red">{{element.developer.firstname}} {{element.developer.lastname}}</p>
                                    <button class="btn btn-primary" v-on:click="edit(element)" v-if="canEdit">Modifier</button>
                                    <br>
                                </div>
                            </div>
                        </div>
                    </draggable>
                </div>
            </div>
        </div>
        <h2 v-else> Aucune Tache a afficher</h2>
    </div>
</template>

<script>
import draggable from 'vuedraggable'
export default {
    data() {
        return {
            newTasks: [],
            DoingTasks: [],
            ValidatedTasks: [],
            InfoTasks: [],
            CancelledTasks: [],
            NonValidatedTasks: []
        }
    },
    props: ['tasks', 'canEdit'],
    computed: {
        progress() {
            if (this.ValidatedTasks && this.ValidatedTasks.length && this.tasks && this.tasks.length) {
                let x = ("" + ((this.ValidatedTasks.length / this.tasks.length) * 100)).split('.');

                if (x[1]) {
                    return x[0] + "." + x[1].substr(0, 2);
                } else {
                    return x[0];
                }
            }
            return 0;
        }
    },
    methods: {
        update(e) {
            let tasks = new Array();
            this.newTasks.forEach((t) => {
                t.status = "Nouvelle";
                tasks.push(t);
            });
            this.DoingTasks.forEach((t) => {
                t.status = "En Cours";
                tasks.push(t);
            });
            this.ValidatedTasks.forEach((t) => {
                t.status = "Testée validée";
                tasks.push(t);
            });
            this.InfoTasks.forEach((t) => {
                t.status = "Besoin information";
                tasks.push(t);
            });
            this.CancelledTasks.forEach((t) => {
                t.status = "Annulée";
                tasks.push(t);
            });
            this.NonValidatedTasks.forEach((t) => {
                t.status = "Testée non validée";
                tasks.push(t);

            });
            this.$emit('update', tasks);
            return tasks;
        },
        tasksArrived() {
            this.newTasks = new Array();
            this.DoingTasks = new Array();
            this.ValidatedTasks = new Array();
            this.InfoTasks = new Array();
            this.CancelledTasks = new Array();
            this.NonValidatedTasks = new Array();
            this.tasks.forEach((t) => {
                if (t.status === "Nouvelle") {
                    this.newTasks.push(t);
                } else if (t.status === "En Cours") {
                    this.DoingTasks.push(t);
                } else if (t.status === "Testée validée") {
                    this.ValidatedTasks.push(t);
                } else if (t.status === "Besoin information") {
                    this.InfoTasks.push(t);
                } else if (t.status === "Annulée") {
                    this.CancelledTasks.push(t);
                } else if (t.status === "Testée non validée") {
                    this.NonValidatedTasks.push(t);
                }
            });
            this.update();
        },
        edit(task) {
            let tasks = this.update();
            for (let i = 0; i < tasks.length; i++) {
                if (tasks[i].title === task.title) {
                    this.$emit('edit', i);
                    break;
                }
            }
        }
    },
    components: {
        draggable,
    },
    created() {
        let retry = setInterval(() => {
            if (this.tasks.length > 0) {
                this.tasksArrived();
                clearInterval(retry);
            }
        }, 200);
    }
}
</script>

<style scoped>
h1 {
    border-width: 2px;
}

.draggble {
    background-color: lightgrey;
    width: 100%;
    min-height: 50px;
}

.element {
    min-height: 10px;
    width: 100%;
}

.card-title {
    font-size: 18px;
}

.card-text {
    font-size: 14px;
}

.red{
    color:red;
}
</style>
